/* Generated By:JavaCC: Do not edit this line. FIL_J.java */
import java.io.*;
import java.util.*;

import jex.*;

/*****************************************************************************
** The class `FIL_J' implements a parser for the Java-to-FIL mapping language
** (FIL-J).
*****************************************************************************/

public class FIL_J implements FIL_JConstants {
        private static Hashtable/*FrameClass,Vector<Frame>*/ _frameClasses=
                                                             new Hashtable();

        /********************************************************************/
        // static FIL_J.getFrame : FrameClass x int -> Frame
        /*********************************************************************
	** Looks up the <i>n</i>th instance of the given FrameClass. Note that
	** the instance numbers here are as specified in the FIL_J file rather
	** than the instance numbers frames are given internally.
	** @param frameClass The frame class of the frame to look up.
	** @param number The instance number (as specified in the FIL_J file)
	**  of the frame to look up.
	** @return The frame of that frame class which has that number.
	*********************************************************************/

        public static Frame getFrame (FrameClass frameClass, int number) {
                Vector frames= (Vector)_frameClasses.get(frameClass);
                if (frames == null)
                        _frameClasses.put(frameClass, frames= new Vector());
                if (number >= frames.size())
                        frames.setSize(number+1);

                Frame frame= (Frame)frames.elementAt(number);
                if (frame == null) {
                        frame= new Frame(frameClass);
                        frames.setElementAt(frame,number);
                }
                return frame;
        }

        /********************************************************************/
        // static FIL_J.main : String[] -> void
        /*********************************************************************
	** Runs the FIL_J parser on given input.
	** @param argv The vector of command line arguments. Each argument is
	** either an EXPRESS (<tt>.exp</tt>) file from which to construct the
	** frame classes (do not include <tt>frame_classes.exp</tt> as that is
	** read automatically) or an FIL_J (<tt>.filj</tt>) file for instances
	** of those frame classes. At most one of the arguments can be a case
	** library (<tt>.cas</tt>) file.
	*********************************************************************/

        public static void main (String args[]) throws ParseException {
                FIL_J parser= null;
                String filename= null;

                Frame._markFramesAsInputModel= false;

                for (int a= 0; a < args.length; a++)
                        if (args[a].endsWith(".exp")) try {
                                JexToFrames.convert((Model)Model.readText
                                                   (new File(args[a])), true);
                        }
                        catch (FileNotFoundException fnfe) {
                                System.err.println ("FileNotFoundException: "
                                + args[a]);
                                System.exit(1);
                        }
                        catch (IOException ioe) {
                                System.err.println(ioe.getMessage());
                                System.exit(1);
                        }
                        catch (Throwable t) {
                                System.err.println(t);
                                t.printStackTrace(System.err);
                        }

                for (int a= 0; a < args.length; a++) {
                        if (args[a].endsWith(".filj"))
                                try {
                                        FileInputStream fis= null;
                                        if (parser == null)
                                                parser= new FIL_J(fis=
                                                new FileInputStream(args[a]));
                                        else
                                                parser.ReInit(fis=
                                                new FileInputStream(args[a]));
                                        System.out.println("\nParsing " +
                                                           args[a] + "...");
                                        _frameClasses= new Hashtable();//purge
                                        parser.Start();
                                        fis.close();
                                        System.out.println("Done.");
                                } catch (FileNotFoundException e) {
                                        System.err.println(args[a]
                                                + " not found!");
                                        System.exit(1);
                                } catch (IOException ioe) {
                                        System.err.println("FIL_J.main: "
                                        + "An IOException occurred.");
                                        System.exit(1);
                                }
                }

                if (parser == null) {
                        System.out.println("No FIL-J file given - "
                                + "reading from standard input...");
                        _frameClasses= new Hashtable();
                        (new FIL_J(System.in)).Start();
                }

                System.out.println();
        }

////////////////////////////////
// Start::= (Instance)* <EOF> //
////////////////////////////////
  final public void Start() throws ParseException {
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INSTANCE:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      Instance();
    }
    jj_consume_token(0);
  }

/////////////////////////////////////////////////////
// Instance::= <INSTANCE> <IDENTIFIER>             //
//             ("#" <NUMBER>                       //
//             |                                   //
//              "(" <IDENTIFIER> <IDENTIFIER> ")") //
//             ";"                                 //
//             (Slot)*                             //
//             <END_INSTANCE> ";"                  //
/////////////////////////////////////////////////////
  final public void Instance() throws ParseException {
        Token i,j=null,k=null,n;
        FrameClass c= null;
        FrameInterface f= null;
    jj_consume_token(INSTANCE);
    i = jj_consume_token(IDENTIFIER);
                c= FrameClass.lookup(i.image);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 17:
      jj_consume_token(17);
      n = jj_consume_token(NUMBER);
                f= getFrame(c,Integer.parseInt(n.image));
      break;
    case 18:
      jj_consume_token(18);
      j = jj_consume_token(IDENTIFIER);
      k = jj_consume_token(IDENTIFIER);
      jj_consume_token(19);
                try {
                        f=new FrameTemplate(c,
                                            Class.forName("jex." + j.image),
                                            k.image);
                }
                catch (ClassNotFoundException cnfe) {
                        System.err.println("Class \"jex." + j
                                         + "\" not found!");
                        System.exit(1);
                }
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(20);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      Slot(f);
    }
    jj_consume_token(END_INSTANCE);
    jj_consume_token(20);
  }

////////////////////////////////////////
// Slot::= <IDENTIFIER> "=" Value ";" //
////////////////////////////////////////
  final public void Slot(FrameInterface f) throws ParseException {
        Token s;
        Object v;
    s = jj_consume_token(IDENTIFIER);
    jj_consume_token(21);
    v = Value();
    jj_consume_token(20);
                try {
                        f.setSlotFiller(s.image,v);
                } catch (InvalidSlot x) {
                        System.err.println("The slot `" + s.image
                                + "' is invalid!");
                        System.exit(1);
                }
  }

////////////////////////////////////////////
// Value::= ["+" | "-"] <NUMBER>          //
//        | <REAL>                        //
//        | <STRING>                      //
//        | <LOGICAL>                     //
//        | <NULL>                        //
//        | "?" <IDENTIFIER>              //
//        | <IDENTIFIER> "#" <NUMBER>     //
//        | <IDENTIFIER> "(" Value() ")"  //
//        | <IDENTIFIER>                  //
//        | "{" (ValueList())? "}"        //
//        | "[" (ValueList())? "]"        //
//        | <IDENTIFIER> InvocationList() //
////////////////////////////////////////////
  final public Object Value() throws ParseException {
        Token t,u,j,m;
        Object v;
        boolean n= false;
        UnorderedVector uo;
        OrderedVector o;
        Vector p;
        DefinedType d= null;
        InvocationList il;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NUMBER:
    case 22:
    case 23:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 22:
      case 23:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 22:
          jj_consume_token(22);
          break;
        case 23:
          jj_consume_token(23);
                    n= true;
          break;
        default:
          jj_la1[3] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[4] = jj_gen;
        ;
      }
      t = jj_consume_token(NUMBER);
                if (n) {
                        {if (true) return new Long("-" + t.image);}
                        n= false;
                } else {
                        {if (true) return new Long(t.image);}
                }
      break;
    case REAL:
      t = jj_consume_token(REAL);
                {if (true) return new Double(t.image);}
      break;
    case STRING:
      t = jj_consume_token(STRING);
                {if (true) return new FILString
                       (t.image.substring(1, t.image.length() - 1));}
      break;
    case BINARY:
      t = jj_consume_token(BINARY);
                {if (true) return new Binary(t.image);}
      break;
    case LOGICAL:
      t = jj_consume_token(LOGICAL);
                if (t.image.equalsIgnoreCase("TRUE"))
                        {if (true) return Logical.TRUE;}
                else if (t.image.equalsIgnoreCase("FALSE"))
                        {if (true) return Logical.FALSE;}
                else
                        {if (true) return Logical.UNKNOWN;}
      break;
    case NULL:
      t = jj_consume_token(NULL);
                {if (true) return new Null();}
      break;
    default:
      jj_la1[7] = jj_gen;
      if (jj_2_1(2)) {
        t = jj_consume_token(IDENTIFIER);
        jj_consume_token(17);
        u = jj_consume_token(NUMBER);
                {if (true) return getFrame(FrameClass.lookup(t.image),
                                Integer.parseInt(u.image));}
      } else if (jj_2_2(2)) {
        t = jj_consume_token(IDENTIFIER);
        jj_consume_token(18);
        v = Value();
        jj_consume_token(19);
                d= DefinedType.lookup(t.image);
                {if (true) return new DefinedTypeInstance(d,v);}
      } else if (jj_2_3(2)) {
        jj_consume_token(IDENTIFIER);
                il= new InvocationList();
        InvocationList(il);
                {if (true) return il;}
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          t = jj_consume_token(IDENTIFIER);
                {if (true) return new EnumSymbol(t.image);}
          break;
        case 24:
          jj_consume_token(24);
          t = jj_consume_token(IDENTIFIER);
                {if (true) return new Variable(t.image);}
          break;
        case 25:
          jj_consume_token(25);
                uo= new UnorderedVector();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LOGICAL:
          case NULL:
          case IDENTIFIER:
          case REAL:
          case NUMBER:
          case STRING:
          case BINARY:
          case 22:
          case 23:
          case 24:
          case 25:
          case 27:
            ValueList(uo);
            break;
          default:
            jj_la1[5] = jj_gen;
            ;
          }
          jj_consume_token(26);
                {if (true) return uo;}
          break;
        case 27:
          jj_consume_token(27);
                o= new OrderedVector();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LOGICAL:
          case NULL:
          case IDENTIFIER:
          case REAL:
          case NUMBER:
          case STRING:
          case BINARY:
          case 22:
          case 23:
          case 24:
          case 25:
          case 27:
            ValueList(o);
            break;
          default:
            jj_la1[6] = jj_gen;
            ;
          }
          jj_consume_token(28);
                {if (true) return o;}
          break;
        default:
          jj_la1[8] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    throw new Error("Missing return statement in function");
  }

/////////////////////////////////////
// ValueList::= Value ("," Value)* //
/////////////////////////////////////
  final public void ValueList(Vector v) throws ParseException {
        Object e;
    e = Value();
                v.addElement(e);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 29:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_3;
      }
      jj_consume_token(29);
      e = Value();
                v.addElement(e);
    }
  }

///////////////////////////////////////////////////
// InvocationList::= "." MethodCall ("." Value)* //
///////////////////////////////////////////////////
  final public void InvocationList(InvocationList il) throws ParseException {
        MethodCall mc;
    jj_consume_token(30);
    mc = MethodCall();
                il.addElement(mc);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 30:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_4;
      }
      jj_consume_token(30);
      mc = MethodCall();
                il.addElement(mc);
    }
  }

////////////////////////////////////////////////////
// MethodCall::= <IDENTIFIER> "(" ValueList() ")" //
////////////////////////////////////////////////////
  final public MethodCall MethodCall() throws ParseException {
        Token m;
        Vector p;
    m = jj_consume_token(IDENTIFIER);
                p= new Vector();
    jj_consume_token(18);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LOGICAL:
    case NULL:
    case IDENTIFIER:
    case REAL:
    case NUMBER:
    case STRING:
    case BINARY:
    case 22:
    case 23:
    case 24:
    case 25:
    case 27:
      ValueList(p);
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
    jj_consume_token(19);
                {if (true) return new MethodCall(m.image,p);}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_3_2() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(18)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_5() {
    if (jj_scan_token(30)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(17)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_5()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public FIL_JTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[12];
  final private int[] jj_la1_0 = {0x100,0x60000,0x1000,0xc00000,0xc00000,0xbc1fc00,0xbc1fc00,0xc1ec00,0xb001000,0x20000000,0x40000000,0xbc1fc00,};
  final private JJCalls[] jj_2_rtns = new JJCalls[3];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public FIL_J(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new FIL_JTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public FIL_J(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new FIL_JTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public FIL_J(FIL_JTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(FIL_JTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[31];
    for (int i = 0; i < 31; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 12; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 31; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 3; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
