      ////////////////////////////////////////
     // THE CONSTRAINT-UNDERSTANDING SYSTEM //
    //  (Version 2)                        ///
   // Written by Andrew Broad             ////
  //                                     /////
 // Null.java (1999:11:25 12:23)        /////
////////////////////////////////////////////
// Methods of Null:                    ////
// - Null constructor                  ///
// - FILise                            //
////////////////////////////////////////

import java.io.*;

/*****************************************************************************
** The class `Null' represents a value of null in two circumstances:
** <LI> When the problem part of a case explicitly specifies a null slot
**      filler, the filler in the case is represented internally as an
**      instance of Null (since representing it as null means that the case
**      does not specify a filler for the slot).
** <LI> When a variable is bound to null, its binding is represented
**      internally as an instance of Null (since representing it as null means
**      that the variable is unbound).
*****************************************************************************/

public class Null implements Serializable, FILisable {

	/********************************************************************/
	// Null.FILise : boolean -> String
	/*********************************************************************
	** Returns a string representing Null in FIL.
	** @param HTML If true, the FIL will be augmented with HTML tags.
	** @return A string representing Null in FIL.
	*********************************************************************/

	public String FILise (boolean HTML) {
		return "null";
	}
}