      ///////////////////////////////////////////////
     // THE CONSTRAINT-UNDERSTANDING SYSTEM        //
    //  (Version 2)                               ///
   // Written by Andrew Broad                    ////
  //                                            /////
 // OrderedVector.java (1999:11:25 12:24)      //////
////////////////////////////////////////////////////
// Methods of OrderedVector:                   ////
// - OrderedVector constructor()               ///
// - FILise                                    //
////////////////////////////////////////////////

import java.io.*;
import java.util.*;

import jex.*;

/*****************************************************************************
** The class `OrderedVector' is a subclass of vectors that represent lists or
** arrays in the frame system.
*****************************************************************************/

public class OrderedVector    extends Vector
                           implements FILisable
{
	/********************************************************************/
	// OrderedVector constructor : void ->
	/*********************************************************************
	** Constructs an empty ordered vector.
	*********************************************************************/
 
 	public OrderedVector () {
		super();
	}
	
	/********************************************************************/
	// OrderedVector.FILise : boolean -> String
	/*********************************************************************
	** Writes FIL for this ordered vector. Elements are enclosed in square
	** square brackets and separated by commas. Elements are FIL-ised
	** recursively.
	** @param HTML If true, FIL will be augmented with HTML tags.
	** @return The FIL representation of this ordered vector.
	*********************************************************************/

	public String FILise (boolean HTML) {
		String agg= "[";

		for (int i= 0; i < size(); i++) {
			Object element= elementAt(i);
			if (element instanceof FILisable)
				agg+= ((FILisable)element).FILise(HTML);
			else
				agg+= element;
			if (i < (size() - 1))
			agg+= ", ";
		}
		return agg + "]";
	}
}
